=== debian/changelog ===
tanks (0+git20251122+ds-1) unstable; urgency=medium

  * Initial release. (Closes: #1121166)

 -- Alex Myczko <tar@debian.org>  Fri, 21 Nov 2025 07:41:11 +0100
