=== debian/control ===
Source: tanks
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Alex Myczko <tar@debian.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 libsdl2-dev,
 libsdl2-image-dev,
 libsdl2-ttf-dev,
 fonts-sixtyfour,
Standards-Version: 4.7.2
Homepage: https://github.com/krystiankaluzny/Tanks
Vcs-Browser: https://salsa.debian.org/games-team/tanks
Vcs-Git: https://salsa.debian.org/games-team/tanks.git

Package: tanks
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 fonts-sixtyfour,
Description: Tank 1990 clone
 This is a game for one or two players controlling a tank.
